/* Init programm for the access counter for HTML pages. This        */
/* checks GoServe's audit file archive (goarch.80) and initializes  */
/* access counter's data file (acscount.log).                       */
/* ================================================================ */
/* Before using this program read OFAEGF's documentation!!!!!!!!!!! */
/* ================================================================ */
/* Written by by Michael Warmuth for OS/2 Forum Austria.            */
/* (E-mail: Michael.Warmuth@wu-wien.ac.at).                         */
/* For using and copiing see the file copyright.doc.                */


parse source . . f.progdir
f.progdir = left(f.progdir,lastpos('\',f.progdir)-1)
call directory f.progdir


/* Load the REXX Utility Functions */
if rxfuncquery('SysLoadFuncs') then do
   call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
   call SysLoadFuncs
end  /* Do */


/* Set global variables and constants */
f.archfile = 'goarch.80'                     /* GoServe's audit archive */
f.crlf='0d0a'x                               /* often useful */
f.dir = strip(SysIni('GOSERVE.INI','GoServe.80','DataDir'),,'00'x) /* GoServe's data path */
                           /* Data directory (root of all data directories) */
                           /* [must include drive and end in '/'] */

say 'Determining lenght of archive file. Please wait ...'
call SysFileSearch ' ', f.archfile, 'lines.'
say ''
a_lines = lines.0
drop lines.
call charout , 'Lines to check:' a_lines '     Checking line: '
parse value SysCurPos() with a_row a_col

do a_i=1 by 1 while lines(f.archfile)
   call SysCurPos a_row, a_col
   call charout , a_i
   /*trace ?intermediates*/
   parse value linein(f.archfile) with . a_code a_num a_txt

   select
      when a_code = 'S' then do
         parse var a_txt a_verb.a_num ' ' a_sel.a_num ' ' a_prot.a_num '/' .
      end  /* Do */
      when a_code = 'C' then do
         f.rsel = a_sel.a_num
         protocol = a_prot.a_num
         verb = a_verb.a_num

         /* Get configuration */
         call goconf                                  /* Call configuration sever */

         call logselector
      end  /* Do */
   otherwise
   end  /* select */
end /* do */

say ''
say ''
call charout , 'Requests to write:' f.clines.0 '     Writing line: '
parse value SysCurPos() with a_row a_col

do i=1 to f.clines.0
   call SysCurPos a_row, a_col
   call charout , i
   parse var f.clines.i f.sel gotnum
   call write_logging gotnum
end /* do */

exit


logselector:

f.rsel = strip(f.rsel,'l','/')               /* Strip leading slashes */
f.sel = f.rsel                               /* Selector variable for manipulations */
f.file = ''                                  /* Init var */

f.iconsel  = substr(f.icons_direc,2)         /* Search path for icons */
f.iconpath = translate(f.dir||f.iconsel,'\','/')   
f.cmdsel  = substr(f.scrip_direc,2)          /* Search path for scripts */
f.cmdpath = translate(f.dir||f.cmdsel,'\','/')  
f.runcmd = 1                                 /* Flag for scripts */
f.doinclude = 1                              /* Flag for server side includes commands */


/* Check request */
if left(protocol,4)\='HTTP' & protocol\='' then return
   

/* Correct vars if user specific URL is requested */
if left(f.sel,1)=f.users_start then do
   tmp_user = substr(f.sel,2,pos('/',f.sel'/')-2)
   usrfound = 0
   /* Check for all user URLs */
   do i=1 to f.users_.0 while \usrfound
      if tmp_user=word(f.users_.i,1) then do
         /* Redirect client if ther is no slash in request */
         if pos('/',f.sel)=0 then do
            return
         end  /* Do */
         usrfound = 1
         f.dir = word(f.users_.i,2)          /* User's data dir */
         f.sel = substr(f.sel,pos('/',f.sel)+1) /* Relative selector */
         flags = translate(word(f.users_.i,3))  /* Flags for user */
         f.users_confi = translate(f.dir||f.users_confi,'\','/')  /* Config file */

         /* Read user's configuration file (if exists) */
         if stream(f.users_confi,'c','query exists')\='' then do
            do while stream(f.users_confi,'c','open read')\='READY:'; end
            found = 0
            do while lines(f.users_confi)\=0 /* With all lines of file */
               next_line = linein(f.users_confi)   /* Read next line */
               br_on = pos('[',next_line)    /* Find brackets and remark symbol */
               br_off = pos(']',next_line)
               rem_on = pos('#',next_line)
               if rem_on=0 then rem_on=999   /* If there is no remark in line */
               if br_on=1 & br_off\=0 & rem_on>br_off then do /* Section heading */
                  parse var next_line '['section_name']' /* Get section name */
                  section_name = 'u.'strip(left(section_name,5))  /* Get first five chars */
                  found = 1                  /* Set found flag */
               end  /* Do */
               else if found then do
                  equ_pos = pos('=',next_line)  /* Find equal sign */
                  if equ_pos\=0 & rem_on>equ_pos then do /* No remark line */
                     parse var next_line key_name'='key_value'#'  /* Get key name and value */
                     key_name = strip(left(strip(key_name),5)) /* Format key name */
                     key_value = strip(key_value)  /* Remove blanks from key value */
                     key_value2 = ''
                     /* Double single quotes */
                     do while pos("'",key_value)
                        parse var key_value tmp "'" key_value
                        key_value2 = key_value2||tmp||"''"
                     end /* do */
                     key_value = key_value2||key_value
                     drop tmp key_value2
                     interpret section_name'_'key_name "= '"key_value"'"   /* Build line */
                  end  /* Do */
               end  /* Do */
            end /* do */
            /* Close configuration file */
            call stream f.users_confi, 'c', 'close'
         end  /* Do */
         /* Change index file names */
         if symbol('u.index_files')\='LIT' & u.index_files\='' then
            f.index_files = u.index_files
         /* Change search path for icons */
         if pos('I',flags)\=0 then do
            if symbol('u.icons_direc')\='LIT' & u.index_files\='' then
               f.iconsel = substr(u.icons_direc,2)
               f.iconpath = translate(f.dir||f.iconsel,'\','/')
         end  /* Do */
         /* Change search path for external scripts */
         if pos('C',flags)\=0 then do
            if symbol('u.scrip_direc')\='LIT' & u.scrip_direc\='' then
               f.cmdsel = substr(u.scrip_direc,2)
               f.cmdpath = translate(f.dir||f.cmdsel,'\','/')
         end  /* Do */
         else f.runcmd = 0
         /* Check if SSIs are allowed */
         if pos('S',flags)=0 then f.doinclude = 0
      end  /* Do */
   end  /* Do */
   drop tmp_user usrfound i flags iconsdir cmddir next_line br_on br_off rem_on section_name,
      equ_pos key_name key_value found u.    /* Drop use vars */
end  /* Do */

/* Expand paths with double dots (..) to absolute paths */
if pos('..',f.sel)\=0 then do
   orig_sel = f.sel
   f.sel = '/'f.sel                          /* makes it a bit easier */
   /* Do with all dots */
   do while pos('/..',f.sel)\=0
      parse var f.sel filepart1 '/..' +4 filepart2
      /* We can't go above the root directory */
      if substr(filepart1,2)='' then do
         return
      end  /* Do */
      f.sel = left(filepart1,lastpos('/',filepart1))||filepart2
   end /* do */
   f.sel = substr(f.sel,2)                   /* remove leading slash */
   drop filepart1 filepart2 orig_sel
end  /* Do */

/* Now carry out whichever verbs we support */
f.file=translate(f.dir||f.sel,'\','/')       /* full filename */


select

   /* Allow some special 'control' requests.  For these, the verb is */
   /* ignored (though would usually be GET) */
   when left(f.sel,1)=f.speci_code then do
      select
         /* Request for options page */
         when f.sel=f.speci_code||'options' then do
            call ext_logging
            return
         end  /* Do */
         /* Request for options page */
         when f.sel=f.speci_code||'options_change' then do
            call ext_logging
            return
         end  /* Do */
         otherwise
            do i=1 to f.speci_.0                   /* Check all available commands */
               parse var f.speci_.i sp_control sp_user sp_command /* Get vars */
               if f.sel=sp_control then do         /* If command matches */
                  if translate(sp_user)\='ALL' then
                     call ext_logging
                     return
               end  /* Do */
            end /* do */
            return
      end  /* Select */
   end  /* Do */

   /* Requests for hidden files or with asterisk (*) are not allowed */
   when substr(f.sel,lastpos('/',f.sel)+1,1)=f.acces_hidde | pos('*',f.sel)\=0 then do
      return
   end  /* Do */

   when verb='GET' | verb='HEAD' then do
      /* First see if it's a query or image click */
      parse var f.sel type '?' words
      /* We don't need to run a script */
      if words='' & translate(right(f.sel,length(f.scrip_exten)))\=translate(f.scrip_exten) then do
         select

            /* File exists: send it */
            when stream(f.file, 'c', 'query exists')\='' then nop
   
            /* This is a directory */
            when right(f.file,1)='\' then do
               /* Look if this is a directory */
               call SysFileTree left(f.file,length(f.file)-1), 'files', 'd'
               if files.0\=0 then do
                  /* Convert directory selector */
                  call checksel
      
                  /* There is no predefinded index file: return auto-index */
                  if right(f.sel,1)='/' then call dirindex
               end  /* Do */
               else return
            end  /* Do */

            otherwise
               call SysFileTree f.file, 'files', 'd' /* Look if this is a directory */
               if files.0\=0 then do
                  return
               end  /* Do */

               /* Maybe this is an icon */
               f.sel = filespec('name',f.sel)
               f.file = f.iconpath||f.sel
               f.sel = f.iconsel||f.sel
               if stream(f.file,'c','query exists')='' then
                  return

         end  /* Select */

         call ext_logging
         return

      end  /* Do */
  
      /* We have to run a script */
      if f.runcmd then call runscript f.sel
      else return
   end /* get */
 
   when verb='POST' then do
      if f.runcmd then call runscript f.sel
      else return
   end  /* Do */
 
   otherwise
      return
end /* select verb */

return
/* [cannot reach here] */


/* ----------------------------------------------------------------------- */
/* RUNSCRIPT: Run a script and return response.                            */
/* ----------------------------------------------------------------------- */
/* This routine should stay in the main filter program.                    */
runscript: procedure expose f.

parse arg type '?' .

cmd_file = translate(f.dir||type,'\','/')
/* Look for the script file */
if stream(cmd_file,'c','query exists')='' then do
   /* If it doesn't exist look into the script directory */
   f.sel = filespec('name',cmd_file)
   cmd_file = f.cmdpath||f.sel
   f.sel = f.cmdsel||f.sel
   if stream(cmd_file,'c','query exists')='' then do
      return
   end  /* Do */
end  /* Do */
/* Get path of script file */
cmd_path = left(cmd_file,lastpos('\',cmd_file)-1)

data_dir = translate(f.dir,'\','/')          /* Get path for data dir */

call ext_logging

return


/* ----------------------------------------------------------------------- */
/* CHECKSEL: Return corrected selector variable "sel".                     */
/* ----------------------------------------------------------------------- */
checksel: procedure expose f.

found = 0                                    /* Clear found flag */
do i=1 to words(f.index_files) until found   /* Test all index filenames */
   next_word = word(f.index_files,i)
   if stream(f.file||next_word,'c','query exists')\='' then do
      f.sel = f.sel||next_word               /* Change selector */
      f.file = f.file||next_word
      found = 1                              /* Set found flag */
   end  /* Do */
end /* do */

return                                       /* Return */


/* ----------------------------------------------------------------------- */
/* DIRINDEX: Return selector for directory index.                          */
/* ----------------------------------------------------------------------- */
dirindex: procedure expose f.

f.file = f.file||f.direc_cache

f.sel = f.sel||f.direc_cache                 /* Cachefile */

return                                       /* Return goserve instruction */



/* ----------------------------------------------------------------------- */
/* EXT_LOGGING: Extended logging routines.                                 */
/* ----------------------------------------------------------------------- */
/* This routine should stay in the main filter program.                    */
ext_logging: procedure expose f.

/* Correct selector */
if left(f.rsel,1)=f.users_start then do
   f.sel = left(f.rsel,pos('/',f.rsel))||f.sel
end  /* Do */


/* Counter logging */
/* Create log file if not existing */
if symbol('f.clines.0')='LIT' then do
   f.clines.0 = 0
end  /* Do */

/* Search line */
c.found = 0
c.eof = 0
c.add = 0
do i=1 by 1 while \c.eof
   /* Get next line */
   parse var f.clines.i c.nextrequ c.nextnum

   /* Set eof flag if at end of file */
   if i>f.clines.0 then do
         c.eof = 1
   end  /* Do */

   /* If not found already */
   if \c.found then do
      select
         /* Found the line */
         when translate(c.nextrequ)=translate('/'f.sel) then do
            c.found = 1
            c.lineno = i
            c.line = c.nextrequ c.nextnum+1
         end  /* Do */
         /* Line not found */
         when translate(c.nextrequ)>translate('/'f.sel) | c.eof then do
            c.found = 1
            c.add = 1
            c.lineno = i
            c.line = '/'f.sel 1
         end  /* Do */
         otherwise nop
      end  /* Select */
   end  /* Do */
end  /* Do */
if c.add then do
   f.clines.0 = f.clines.0 + 1
   do i=f.clines.0 to c.lineno+1 by -1
      j = i - 1
      f.clines.i = f.clines.j
   end /* do */
end  /* Do */
j = c.lineno
f.clines.j = c.line

/* Drop used vars */
drop c.

return



/* ----------------------------------------------------------------------- */
/* WRITE_LOGGING: Extended logging routines.                               */
/* ----------------------------------------------------------------------- */
/* This routine should stay in the main filter program.                    */
write_logging: procedure expose f.

parse arg gotno

/* Counter logging */
/* Create log file if not existing */
if stream(f.loggi_count,'c','query exists')='' then do
   call lineout f.loggi_count, '[  date     time  ] request     number'
   call lineout f.loggi_count, copies('-',79)
   call stream f.loggi_count, 'c', 'close'
end  /* Do */

/* Open log file */
do while stream(f.loggi_count,'c','open')\='READY:'; end
call linein f.loggi_count
call linein f.loggi_count

/* Search line */
c.found = 0
c.eof = 0
do i=1 by 1 while \c.eof
   /* Get next line */
   c.curpos = chars(f.loggi_count)
   c.lines.i = linein(f.loggi_count)
   parse var c.lines.i '[' c.nextdate c.nexttime ']' c.nextrequ c.nextnum

   /* Set eof flag if at end of file */
   if pos('1a'x,c.lines.i)\=0 | \lines(f.loggi_count) then do
         c.eof = 1
   end  /* Do */

   /* If not found already */
   if \c.found then do
      select
         /* Found the line */
         when translate(c.nextrequ)=translate(f.sel) then do
            c.found = 1
            c.lineno = i
            c.foundpos = c.curpos
            c.lines.i = '['c.nextdate c.nexttime']' c.nextrequ c.nextnum+gotno
         end  /* Do */
         /* Line not found */
         when translate(c.nextrequ)>translate(f.sel) | c.eof then do
            c.found = 1
            j = i + 1
            c.lines.j = c.lines.i
            c.lineno = i
            c.foundpos = c.curpos
            c.lines.i = '['date('o') time('n')']' f.sel gotno
            i = i + 1
         end  /* Do */
         otherwise nop
      end  /* Select */
   end  /* Do */
end  /* Do */
c.lines.0 = i - 1

/* Do the logging */
call stream f.loggi_count, 'c', 'seek <'c.foundpos
do i=c.lineno to c.lines.0
   call lineout f.loggi_count, c.lines.i
end  /* Do */
if chars(f.loggi_count)>1 then do
   call charout f.loggi_count, '1a'x
   call charout f.loggi_count, copies(' ',chars(f.loggi_count))
end  /* Do */

/* Close log file */
call stream f.loggi_count, 'c', 'close'

/* Drop used vars */
drop c.

return



/* ----------------------------------------------------------------------- */
/* CONFIGURATION SERVER: Don't change anything below this comment.         */
/* ----------------------------------------------------------------------- */
/* This routine must stay in the main filter program as the last routine.  */
/* ----- Begin of automatic created program part ------------------------- */
/* ----- End of automatic created program part --------------------------- */
